import processing.core.*; 
import processing.xml.*; 

import java.awt.Point; 
import java.awt.Rectangle; 
import java.util.List; 
import java.util.ArrayList; 
import krister.Ess.*; 

import krister.Ess.*; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class asteroids extends PApplet {









// Globals for Debugging
boolean noSound = false;	// Turn off sounds
boolean noHit = false;		// Turn off hit testing 

/**
 * TODO
 * o Character Generator for Asteroid Font
 * o High Scores
 */
public void setup() {
//	size(500, 375);   // blog
	size(640, 480); // decent
	//size(800, 675); // nice
	frameRate(30);
	smooth();

	fontA = loadFont("CourierNew36.vlw");
    
	// Start sound
	Ess.start(this); // Start Ess
	sounds = new Sounds();

	game = new Game();
	game.init(true);
	
	println("Game Started");
	println("Size = (" + width + ", " + height + ")");

}

//int count = 0;

public void draw() {
	try {
		game.draw();
	}
	catch (Exception e) {
		e.printStackTrace();
	}

//        save("shot" + nf(count, 6) + ".jpg");
//        count++;
}

public void keyPressed() {
	game.controller.keyPressed();
}

public void keyReleased() {
	game.controller.keyReleased();
}

public void mousePressed() {
	game.controller.mousePressed();
}

Game game = null;
PFont fontA;
Sounds sounds;

public final int EXPLODE_BIG = 2;
public final int EXPLODE_MEDIUM = 1;
public final int EXPLODE_SMALL = 0;

static PImage head;

class Asteroid extends FlyingObject {
	Polygon vertices;
	AsteroidFactory.Next next;
	int explodeSound;
        int height;
        int width;
	
    public Asteroid(AsteroidFactory.InitParams options, Polygon vertices, int points, AsteroidFactory.Next next, int explodeSound) {
    	super(options.x, options.y, (int)(vertices.getBounds().width*1.4f), (int)(vertices.getBounds().height*1.4f), options.dx, options.dy);
    	this.vertices = vertices;
    	this.points = points;
    	this.next = next;
    	this.explodeSound = explodeSound;


        if (head == null) {
            head = loadImage("head.png");
            head.resize(92, 115);
        }
        
        this.height = (int)(vertices.getBounds().height*1.4f);
        this.width = (int)(vertices.getBounds().height*1.4f*((float)head.width/head.height));
    }

	public boolean intersects(FlyingObject other) {
		if (other instanceof Asteroid) return false;
		return super.intersects(other);
	}
	
	public void collide(FlyingObject other, List add) {
		super.collide(other, add);
		
		sounds.explode(explodeSound);
		//println("blowing up asteroid sized" + this.explodeSound);
		
		if (next != null)
			next.go(this, add);
	}
	
    public void draw() {
        stroke(255);
        noFill();
        translate(x, y);
//        beginShape();
//		for (int i = 0 ; i < vertices.npoints ; i++)
//			vertex(vertices.xpoints[i], vertices.ypoints[i]);
//		endShape(CLOSE);
        image(head, 0, 0, width, height);
    }
}
class AsteroidFactory {
	public int quadrant = 0;
	
	public Polygon createPolygon(int[][] points) {
		int[] x = new int[points.length], y = new int[points.length];
		
		for (int i = 0 ; i < points.length ; i++) {
			x[i] = points[i][0];
			y[i] = points[i][1];
		}
		
		return new Polygon(x, y, points.length);
	}
	
	public Polygon scaleAsteroid(Polygon points, int scale) {
		Polygon result = new Polygon();
		
		for (int i = 0 ; i < points.npoints ; i++){
			result.addPoint((int)(points.xpoints[i] * (scale/100.0f)), (int)(points.ypoints[i] * (scale/100.0f)));
		}
		
		return result;
	}
	
	final private Polygon[] Shapes = {
		createPolygon(new int[][] { 
		{20, 0}, {80, 0}, {100, 20}, {100, 50}, {60, 100}, {40, 100}, {50, 70}, {25, 90}, {0, 70}, {20, 40}, {0, 20} }),
		
		createPolygon(new int[][] { 
		{20, 0}, {50, 0}, {100, 20}, {100, 30}, {50, 50}, {100, 60}, {75, 100}, {50, 80}, {20, 100}, {0, 60}, {0, 30} }),

		createPolygon(new int[][] { 
		{25, 0}, {50, 10}, {75, 0}, {100, 20}, {70, 45}, {100, 60}, {65, 100}, {30, 90}, {20, 100}, {0, 75}, {10, 50}, {0, 20} }),

		createPolygon(new int[][] { 
		{30, 0}, {50, 20}, {75, 0}, {100, 20}, {80, 50}, {100, 70}, {75, 100}, {30, 100}, {0, 70}, {0, 20} })
		};

	int roid = 0;
	public Polygon nextAsteroid() {
		roid = ++roid % Shapes.length;
		//println("roid is " + roid);
		return Shapes[roid];
	}

	public class InitParams {
		public float x;
		public float y;
		public float dx;
		public float dy;
		private final int theta = 15;
		private final float border = 20.0f;

		public InitParams(int quadrant) {
			int xBorder = (int)(width * border);
			int yBorder = (int)(height * border);
			
			switch (quadrant % 4) {
				case 0:
					this.x = width - xBorder + (int)random(0, xBorder);
					this.y = (int)random(height);
					break;
				case 1:
					this.x = (int)random(0, width);
					this.y = (int)random(0, yBorder);
					break;
				case 2:
					this.x = (int)random(0, xBorder);
					this.y = (int)random(height);
					break;
				case 3:
					this.x = (int)random(0, width);
					this.y = height - yBorder + (int)random(0, yBorder);
					break;
			}
			
			int angle = (int)(random(theta, 90 - theta) + (quadrant % 4) * 90);
			this.dx = cos(radians(angle));
			this.dy = sin(radians(angle));
		}
	}
	public void createSmall()  { 
		game.addObject(createSmallEx(null));
		}
	public void createMedium() { 
		game.addObject(createMediumEx(null));
		}
	public void createLarge()  { 
		game.addObject(createLargeEx(null));
		}
	
	public Asteroid createSmallEx(InitParams ip)  {
		return create(ip, nextAsteroid(), 15, 100, null, EXPLODE_SMALL);
		}
	public Asteroid createMediumEx(InitParams ip) { 
		return create(ip, nextAsteroid(), 40, 50, nextMedium, EXPLODE_MEDIUM);
		}
	public Asteroid createLargeEx(InitParams ip)  {
		return create(ip, nextAsteroid(), 60, 20, nextLarge, EXPLODE_BIG);
		}

	private Asteroid create(InitParams ip, Polygon polygon, int scale, int points, Next next, int explode) {
		InitParams init = ip == null ? new InitParams(quadrant++) : ip;
		polygon = scaleAsteroid(polygon, scale);
	   	return new Asteroid(init, polygon, points, next, explode);
	}
	
	abstract class Creator {
		public abstract Asteroid create(InitParams ip);
	}
	

	/**
	 * Strategy for what happens when an asteroid explodes.  Use the asteroid that
	 * is breaking up as a reference point for position & velocity.
	 */
	class Next {
		Creator creator;
		
		public Next(Creator creator) {
			this.creator = creator;
		}
		
		public void go(Asteroid a, List add) {
			InitParams[] ips = initParams(a);
			
			for (int i = 0 ; i < ips.length ; i++)
				add.add(creator.create(ips[i]));
		}
		
		public InitParams[] initParams(Asteroid a) {
			final float delta = 1;
			InitParams[] result = new InitParams[2];
			result[0] = new InitParams(0);
			result[1] = new InitParams(0);
			
			float dx = random(-delta, delta);
			float dy = random(-delta, delta);
			
			result[0].x = result[1].x = a.x;
			result[0].y = result[1].y = a.y;
			
			result[0].dx = a.dx + dx;
			result[0].dy = a.dy + dy;
			
			result[1].dx = a.dx - dx;
			result[1].dy = a.dy - dy;

			return result;
		}
	}
	
	final Next nextLarge = new Next(new Creator(){
		public Asteroid create(InitParams ip) { return createMediumEx(ip); }
	});
	
	final Next nextMedium = new Next(new Creator(){
		public Asteroid create(InitParams ip) { return createSmallEx(ip); }
	});
}
class DisplayList {
	List objects = new LinkedList();

	public void add(DisplayObject o) {
		objects.add(o);
	}
	
	public void update() {
		ListIterator it = objects.listIterator();
	    
	    while (it.hasNext()) {
	    	DisplayObject fo = (DisplayObject)it.next();
	    	fo.update(it);
	    }
	}
	
	public void hitTest() {
		// Compare all pairs
		ListIterator lit = objects.listIterator(0);
	    ArrayList newObjects = new ArrayList();
	    FlyingObject l, r = null;
	    Object x;
	    
		if (!noHit) {
		    while (lit.hasNext()) {
		    	x = lit.next(); 
		    	if (!(x instanceof FlyingObject)) continue;
		    	
				l = (FlyingObject)x;
				if (l.remove) continue;
				
				ListIterator rit = objects.listIterator(lit.nextIndex());
	
				while (rit.hasNext()) {
			    	x = rit.next(); 
			    	if (!(x instanceof FlyingObject)) continue;
	
					r = (FlyingObject)x;
					if (r.remove) continue;
					
					if (l.intersects(r)) {
						l.collide(r, newObjects);
						r.collide(l, newObjects);
						break;
					}
				}
			}
		}
		
		// Remove dead objects.
		Iterator it = objects.iterator();
		
		while (it.hasNext()) {
			DisplayObject fo = (DisplayObject)it.next();
			
	    	if (fo.remove) {
	    		//println("yanking " + fo.getClass().getName());
	    		it.remove();
	    	}
		}
		
		// Add new objects.
		it = newObjects.iterator();
		
		while (it.hasNext())
			objects.add(it.next());
	}
	
	public Iterator iterator() {
		return objects.iterator();
	}
}
public abstract class DisplayObject {
	public boolean remove = false;
	
    public void update(ListIterator it) { }
    protected abstract void draw();
}
/** 
 * Base class for enemy ships.
 *
 * 200 for big
 * 1000 for small
 */
public class EnemyShip extends FlyingObject {
	Polygon vertices;
	Shot shot = null;
	int radius;
	float savedDY = 0;
	int lastShot = 0;
	float shotDelay = 1;
	int lastDirChange = 0;
	float dirChangeDelay = 1.5f;
	boolean big = false;
	int targetHero = 0;
	int targetHeroEvery = 3;
	
	public EnemyShip(boolean big) {
		super(0, 0, 0, 0, 0, 0);
	
		this.big = big;
			
		int left = 0;
		int right = width - left;
		int top = height/10;
		int bottom = height - top;
		float speed = big ? 1.5f : 2;
		
		switch ((int)random(1, 4)) {
			case 1: x = left;  y = top;    dx =  1; break;
			case 2: x = left;  y = bottom; dx =  1; break;
			case 3: x = right; y = top;    dx = -1; break;
			case 4: x = right; y = bottom; dx = -1; break;
		}
		
		dx = dx * speed;
		dy = 0;
		
		savedDY = speed;
		
		shotDelay = big ? 1 : 0;
		lastShot = frameCount;

		dirChangeDelay = big ? 2.5f : 2;
		lastDirChange = frameCount;
		
		// This looks crummy for small ones, redo, the multiple just isn't good
		// Also make this into a factory - too costly to redo each time.
		vertices = game.asteroidFactory.createPolygon(new int[][] { 
			{40, 0}, {60, 0}, {70, 20}, {100, 40}, {70, 60}, {30, 60}, {0, 40}, {30, 20} });
		
		if (big) {
			points = 200;
			vertices = game.asteroidFactory.scaleAsteroid(vertices, 40);
		}
		else {
			points = 1000;
			vertices = game.asteroidFactory.scaleAsteroid(vertices, 20);
		}
		
		w = vertices.getBounds().width;
		h = vertices.getBounds().height;
		radius = (int)(sqrt(h * h + w * w) / 2) + 1;

		startSounds();
	}

	public void startSounds() {
		if (this.big)
			sounds.bigShip.play();
		else
			sounds.smallShip.play();
	}
	
	public void stopSounds() {
		if (this.big)
			sounds.bigShip.stop();
		else
			sounds.smallShip.stop();
	}
	
    public void collide(FlyingObject other, List add) {
    	super.collide(other, add);
    	sounds.explode(EXPLODE_MEDIUM);
    	stopSounds();
    	
    	game.enemy = null;
    	
    	println("Enemy exploded!");
    	
    	// HACK : Remove after testing
		//game.enemy = new EnemyShip(true);
		//game.addObject(game.enemy);
	}
    
    public void update(ListIterator it) {
    	// If ship is off screen yank it.
    	if ( ((x + dx) > width) || ((x + dx) < -w) ) {
    		println("Enemy off screen");
    		stopSounds();
    		remove = true;
    		game.enemy = null;
    		return;
    	}
    	
    	// Move the ship up, down, or keep it level every x% of the screen.
   		if (frameCount > (lastDirChange + dirChangeDelay * frameRate)) {
   			lastDirChange = frameCount;
   			//println("frameCount=" + frameCount + "," + lastDirChange + "," + dirChangeDelay + "," + frameRate);
   			switch((int)random(0, 100) % 3) {
   				case 0: dy = savedDY; break;
   				case 1: dy = 0; break;
   				case 2: dy = -savedDY; break;
   			}
   		}
    	
    	// Update it
    	super.update(it);
    	
    	if (shot == null || shot.remove) {
    		shot = null;
    		
    		// Wait a bit before firing
    		if (frameCount > (lastShot + shotDelay * frameRate)) {
    			fire(it);
    		}
    	}
    }
    
    private void fire(ListIterator it) {
		lastShot = frameCount;
    	//println("Enemy shot fired!");
    	
    	// small ship shoots right at our hero every 3rd shot
    	if (!this.big) {
    		targetHero = (targetHero + 1) % targetHeroEvery;
    	}
    	
    	float l = x, t = y, a = 135;

    	if (!this.big && targetHero == 0) {
			Rectangle r = game.ship.rect();
	   		Rectangle d = this.rect();
	   		//println("ship is  at " + r.toString() + ", enemy at " + d.toString());
	   		d.translate((int)-r.x, (int)-r.y);
	   		//println("ship is  NOW at " + r.toString() + ", enemy at " + d.toString());
	   		translate(r.x, r.y);
			a = degrees(atan2(d.y, -d.x));
	   		translate(-r.x, -r.y);
    	}
    	else {
			a = (int)random(0, 360);
    	}
		
		l = x + w/2 + radius * cos(radians(a));
		t = y + h/2 - radius * sin(radians(a));

		println("Shot = " + a + " @ " + l + ", " + t);

		shot = new Shot(l, t, dx, dy, a);
    	it.add(shot);
    }
		
	public void draw() {
        stroke(0);
        noFill();
        translate(x, y);

        beginShape();
		for (int i = 0 ; i < vertices.npoints ; i++)
			vertex(vertices.xpoints[i], vertices.ypoints[i]);
		endShape(CLOSE);
		
		line(vertices.xpoints[2], vertices.ypoints[2], vertices.xpoints[7], vertices.ypoints[7]);
		line(vertices.xpoints[3], vertices.ypoints[3], vertices.xpoints[6], vertices.ypoints[6]);

	}
}
public class ExplodingShip extends DisplayObject {
	float endAt = frameCount + (frameRate * 2);
	float x,y;
	
	public ExplodingShip(float x, float y) {
		this.x = x;
		this.y = y;
	}
	
	public void update(ListIterator it) {
    	if (frameCount >= endAt) {
    		game.newShip(it);
    		remove = true;
    		return;
    	}
	}	
    public void draw() {
    	float w=20,h=20;
        stroke(0);
        translate(x - 20/2, y - 20/2);
        line(0, 0, w/2, 20);
        line(w/2, 0, 20, h/2);
    }
}
/**
 * All explosions look like a little puff of dust extending out from the center of what
 * exploded.  You can choose a size from small to large.
 */
public class Explosion extends DisplayObject {
	float x, y;
	final int lifetime = 1;  // Lifetime in seconds
	private int end;
	private int[][] pts = { { 0, 1, 0 }, { 90, 2, 0 }, { 180, 1, 0 }, { 250, 2, 0 } };
	
	public Explosion(float x, float y) {
		this.x = x;
		this.y = y;
		end = (int)(frameCount + frameRate * lifetime);

		// Generate particles velocities.
	}
	
	public void update(ListIterator it) {
		for (int i = 0 ; i < pts.length ; i++)
			pts[i][2] += pts[i][1];
					
		if (frameCount >= end) {
			this.remove = true;
		}
	}
	
	public void draw() {
		translate(x, y);
		stroke(255);
		
		for (int i = 0 ; i < pts.length ; i++) {
			rotate(radians(pts[i][0]));
			point(pts[i][2], 0);
		}
	}
}
abstract class FlyingObject extends DisplayObject {
    protected float dx = 0, dy = 0, da = 7.5f;
    protected float x = 0, y = 0;
    protected int w = 0, h = 0;
    protected float angle = 0;
    protected float dragX, dragY;
    protected boolean applyDrag = false;
    private final float DRAG_X = 0.02f;
    private final float DRAG_Y = 0.02f;
	protected int points = 0;
	protected boolean explodes = true;
	
    protected FlyingObject() {
    }
        
    protected FlyingObject(float x, float y, int w, int h, float dx, float dy) {
        this.x = x;
        this.y = y;
        this.w = w;
        this.h = h;
        this.dx = dx;
        this.dy = dy;
	    this.dragX = DRAG_X;
	    this.dragY = DRAG_Y;
    }
    
    /**
     * Update the object by moving it along it's vector.
     */
    public void update(ListIterator it) {
        x += dx;
        
        if (x > width)
            x = -w;
        else if (x < -w)
            x = width;

        y += dy;
        
        if (y > height)
            y = -h;
        else if (y < -h)
            y = height;
            
        // Put some drag on the ship.
        if (applyDrag) {
	        dx = drag(dx, dragX);
	        dy = drag(dy, dragY);
        }
    }
    
    public boolean intersects(FlyingObject other) {
    	Rectangle r1 = new Rectangle((int)x, (int)y, w, h);
    	Rectangle r2 = new Rectangle((int)other.x, (int)other.y, other.w, other.h);
    	return r1.intersects(r2);
    }
    
    public void collide(FlyingObject other, List add) {
    	//println(this.getClass().getName() + " collided with a " + other.getClass().getName());
    	remove = true;
    	
    	int oldScore = game.getScore();
    	int newScore = game.addPoints(points);
    	
    	// Give a new ship at 10K, then every 25K aftewards.
    	
    	if ((oldScore < 10000 && newScore >= 10000)) {
    		println("NEW SHIP 10,000");
    		game.ships++;
    	}
    	else if ( (newScore > 10000 && ((oldScore % 25000) > (newScore % 25000))) ) {
    		println("NEW SHIP 25,000");
    		game.ships++;
    	}

    	if (explodes)
    		add.add(new Explosion(x, y));
    }
    
    private float drag(float d, float drag) {
        if (d == 0) return d;

        // Bleed off a percent
        float reduceBy = abs(drag * d);
        
        float result = (d > 0) ? constrain(d - reduceBy, 0, d) : constrain(d + reduceBy, d, 0);
        if (abs(frameRate * result) < 1) result = 0;
        //println("Slowing " + d + " to " + result + " == " + frameRate * result);
        return result;
    }
    
    public void rotateLeft() {
        angle = (angle + da) % 360;
        //println("New angle is " + angle);
    }
    public void rotateRight() {
        this.angle -= da;
        if (this.angle < 0) this.angle = (360 + this.angle);
        //println("New angle is " + angle);
    }
    
    public int width() { return w; }
    
    public Rectangle rect() {
		return new Rectangle((int)x, (int)y, w, h);
    }

    protected abstract void draw();
}
class Game {
	Ship ship;
	InputController controller = new InPlayController();
	AsteroidFactory asteroidFactory = new AsteroidFactory();
	DisplayList displayList = new DisplayList();
	private int score = 0;
	int roids = 2;
	int ships = 3;
	int level = 0;
	int timeOnLevel = 0;
	int levelFrameStart;
	boolean waiting = false;
	EnemyShip enemy = null;
	int nextEnemy = 0;

        PImage bgimage;
		
	public void init(boolean home) {
		sounds.killAllSounds();

            if (bgimage == null) {
              bgimage = loadImage("background.png");
              bgimage.resize(width, height);
            }

	    if (home) {
			println("Home Screen");
	    	controller = new NewGameController();
			addObject(new HomeScreen());
			for (int i = 0 ; i < 6 ; i++)
				addObject(asteroidFactory.createLargeEx(null));
			return;
	    }

		// Real game
		addObject(new ScoreBoard());

	    // Create the ship
	    tryAddingShip();
	    
	    newLevel();
	}
	
	public void startNewLevel(ListIterator it) {
		sounds.startLevel();
		waiting = false;
		
		println("Starting level " + level + " with " + roids + " asteroids.");			
		// Add asteroids
		for (int i = 0 ; i < roids ; i++)
			it.add(asteroidFactory.createLargeEx(null));
	}
	
	public void newLevel() {
		waiting = true;
		level++;
		roids = min(roids + 2, 11);
		timeOnLevel = 0;
		levelFrameStart = frameCount;
		println("Next Level : " + level);
		
		// Wait one second before starting the level.
		addObject(new NewGame());
	}
	
	public void addObject(DisplayObject o) {
		displayList.add(o);
	}
	
	public void shipDied() {
		ships--;
		println("Ship died, you have " + ships + " left!");
	}
	
	public void gameOver(ListIterator it) {
		println("Game over!");
		sounds.stopGame();
		controller = new GameOverController();
		it.add(new GameOver());
	}
	
	public int getScore() {
		return score;
	}

	public int addPoints(int points) {
		if (ships > 0)
			score += points;
		return score;
	}
	
	public void newShip(ListIterator it) {
		if (ships == 0) {
			gameOver(it);
			return;
		}
		
		tryNewShip = true;
	}
	
	boolean tryNewShip = false;
	final Dimension safeWH = new Dimension(100, 100);
	
	public void tryAddingShip() {
		// Wait until center is clear
		
	    Point center = new Point(width/2, height/2);

		if (!isSafeZone(center, safeWH)) {
	 		println("Center not clear!");
	 		return;
		}

	    println("Found a clearing!");

	    ship = new Ship(width/2, height/2);
	    addObject(ship);
	    tryNewShip = false;
	}
	
	public Point findSafeZone(Dimension size) {
		println("Finding safe zone of size " + size.toString());
		int MAX_TRIES = 20;
		Point center;
		
		for (int i = 0 ; i < MAX_TRIES ; i++) {
			center = new Point((int)random(width * 0.15f, width * 0.85f), (int)random(height * 0.15f, height * 0.85f));
			println("..." + center.toString());
			
			if (isSafeZone(center, size))
				return center;
		}
		
		return null;
	}
	
	public boolean isSafeZone(Point center, Dimension wh) {
		Rectangle zone = new Rectangle(center.x - wh.width/2, center.y - wh.height/2, wh.width, wh.height);
		println("Checking safe zone " + zone.toString());
	    Iterator it = displayList.iterator();
	    
	    while (it.hasNext()) {
	    	DisplayObject fo = (DisplayObject)it.next();
	    	
	    	if (!(fo instanceof FlyingObject))
	    		continue;
	    	
	    	if (zone.intersects(((FlyingObject)fo).rect())) {
	    		return false;
	    	}
	    }
	    
	    return true;
	}
			
	// Game Loop
	public void draw() {
		if (tryNewShip)
			tryAddingShip();
			
		sounds.playBoop();
		
		int last = timeOnLevel;
		timeOnLevel = (int)((frameCount - levelFrameStart) / frameRate);
		if (timeOnLevel != last) {
			//println("Time on level: " + timeOnLevel + " seconds.");
			//println("" + (frameCount - levelFrameStart) + ", " +  (frameRate * 3));
		}

		// We add our first ship after 30 seconds for levels 1-2, 20 for 3-5
		// then 10 for all those after that.
		if (enemy == null && timeOnLevel > ((level < 3) ? 20 : ((level < 6) ? 15 : 10)) ) {
			if (nextEnemy == 0) {
				nextEnemy = (int)(frameCount + (int)random(10, 20) * frameRate);
				println("Next enemy at " + nextEnemy);
			}
			else if (frameCount >= nextEnemy) {
				println("Adding enemy ship");
				nextEnemy = 0;
				// <= 10K always show big ship, above randomly choose
				enemy = new EnemyShip(score > 10000 ? (int)random(0, 10) % 2 == 1 : true);
				addObject(enemy);
			}
		}
			
		// Check for keyboard action then update the display list.
	    controller.checkKeyboard();
	    displayList.update();
		displayList.hitTest();

		// Draw
            image(bgimage, 0, 0); 

	    Iterator it = displayList.iterator();
	    int asteroids = 0;
	    
	    while (it.hasNext()) {
	    	DisplayObject fo = (DisplayObject)it.next();
	    	if (fo instanceof Asteroid)
	    		asteroids++;
	    	
	    	pushMatrix();
	    	fo.draw();
	    	popMatrix();
	    }
	    
	    if (asteroids == 0 && enemy == null && !waiting)
	    	newLevel();
	}
}
public class GameOver extends DisplayObject {
	public void draw() {
		// Set the font and its size (in units of pixels)
		textFont(fontA, 32);
		textAlign(CENTER);
		
		fill(0);
		text("G A M E   O V E R", width/2, height/2);
	}
}
class GameOverController extends InputController {
	public void keyPressed() { }
	
	public void keyReleased() {
    	newGame();
	}
	
	public void checkKeyboard() { }
	public void mousePressed() { newGame(); }
	
	private void newGame() {
	   	game = new Game();
	   	game.init(true);
	}
}
public class HomeScreen extends DisplayObject {
	int start;
	HomeScreen() {
		start = frameCount;
	}
	public void draw() {
		// Set the font and its size (in units of pixels)
		textFont(fontA, 48);
		textAlign(CENTER);
		
		stroke(0);
		fill(0);
		text("NORMALOIDS", width/2, height * .4f);

		stroke(0);
		fill(0);
		textFont(fontA, 24);
		text("Click or Press A Key To Play", width/2, height * .6f);

		//textFont(fontA, 16);
		//text("A T&T Production", width/2, height - 20);
	}
	
    public void update(ListIterator it) {
    	if (frameCount > start + 5 * 60 * frameRate) {
    		start = frameCount;
    		game = new Game();
    		game.init(true);
    	}
    }
}
class InPlayController extends InputController {
	boolean[] keyPressed = new boolean[256];
	
	public void keyPressed() {
	    if (keyCode == KEY_SPACE && !keyPressed[keyCode])
	        game.ship.fire();
	    if (keyCode == KEY_CTRL && !keyPressed[keyCode])
	        game.ship.hyperspace();

	    if (keyCode < keyPressed.length) {
	        //println("Key pressed == " + keyCode);
	        keyPressed[keyCode] = true;
	    }
	}
	
	public void keyReleased() {
	    if (keyCode < keyPressed.length) {
	        //println("Key released == " + keyCode);
	        keyPressed[keyCode] = false;
	    }
	}
	
	public void checkKeyboard() {
	    if (keyPressed[KEY_LEFT])
	        game.ship.rotateLeft();
	
	    if (keyPressed[KEY_RIGHT])
	        game.ship.rotateRight();
	    if (keyPressed[KEY_UP])
	        game.ship.speedUp();
	    //if (keyPressed[KEY_DOWN])
	    //    game.ship.slowDown();
	}
}
abstract class InputController {
	final int KEY_LEFT = 37;
	final int KEY_UP = 38;
	final int KEY_RIGHT = 39;
	final int KEY_DOWN = 40;
	final int KEY_SPACE = 32;
	final int KEY_CTRL = 17;
	
	public void keyPressed() { }
	public void keyReleased() { }
	public void checkKeyboard() { }
	public void mousePressed() { }
}

/**
 * A display object with a fixed lifetime.
 */
public class NewGame extends DisplayObject {
	int end;
	final int seconds = 1;
		
	public NewGame() {
		end = (int)(frameCount + seconds * frameRate);
	}
		
	public void update(ListIterator it) {
		if (frameCount >= end && !remove) {
			remove = true;
			game.startNewLevel(it);
		}
	}
	
	public void draw() {
	}
}
class NewGameController extends InputController {
	public void keyPressed() { }
	
	public void keyReleased() {
    	newGame();
	}
	
	public void checkKeyboard() { }
	public void mousePressed() { newGame(); }
	
	private void newGame() {
	   	game = new Game();
	   	game.init(false);
	}
}
class ScoreBoard extends DisplayObject {
	private Ship ship;
	int fontSize = 20;
	int topMargin = 16;
	int scoreLeft = 20;
	
	public ScoreBoard() {
		ship = new Ship(50, 50);
	}
	
	public void draw() {
		
		// Set the font and its size (in units of pixels)
		textFont(fontA, fontSize);
		fill(0);
		
		// Score		
		textAlign(RIGHT);
		text(game.getScore(), width - scoreLeft, topMargin);
		
		// Ships
		
		for (int i = 0 ; i < game.ships ; i++) {
	    	pushMatrix();
			ship.drawAt(scoreLeft + i * ship.width() + 5, topMargin/* + fontSize + 58*/);
	    	popMatrix();
		}

		// Level
		//textAlign(RIGHT);
		//text("LEVEL:" + game.level, width, topMargin);
		
	}
}
class Ship extends FlyingObject {
    boolean showThrust = false;
    private final int MAX_DX = 15;
    private final int MAX_DY = 15;
    private int inHyperspace = -1;
    
    public Ship(int x, int y) {
    	super(x, y, 21, 14, 0, 0);
    	this.dragX = this.dragY = 0.0075f;
		angle = 90;
    	applyDrag = true;
    }
    
    public void speedUp() {
    	showThrust = true;
    	this.thrust(0);
    }
    
    // not really used - just for play
    public void slowDown() {
    	this.thrust(180);
    }
    
    private void thrust(int direction) {
    	float factor = 0.27f;
        float boostX = factor * cos(radians(direction + this.angle));
        float boostY = factor * -sin(radians(direction + this.angle));

        //println("Slowing down from (" + dx + "," + dy + ") to (" + (boostX + dx) + "," + (boostY + dy) + ")");
        dx = constrain(dx += boostX, -MAX_DX, MAX_DX);
        dy = constrain(dy += boostY, -MAX_DY, MAX_DY);
    }
    
    public void hyperspace() {
    	if (inHyperspace != -1) return;
    	// find a new point on the screen that's safe for the ship
    	println("--H Y P E R  S P A C E--");
    	inHyperspace = millis();
    }

	/**
	 * Of course we are different, we draw ourself at -w/2, -h/2 to keep rotation about our center.
	 */
    public boolean intersects(FlyingObject other) {
    	if (inHyperspace != -1) return false;
    	Rectangle r1 = new Rectangle((int)x - w/2, (int)y - h/2, max(w, h), max(w, h));
    	Rectangle r2 = new Rectangle((int)other.x, (int)other.y, other.w, other.h);
    	return r1.intersects(r2);
    }
    
    public void collide(FlyingObject other, List add) {
    	super.collide(other, add);
    	
    	game.shipDied();
    	println("Adding exploding ship");
    	add.add(new ExplodingShip(x, y));
    }
    
    public void fire() {
    	if (inHyperspace != -1) return;
    	if (remove) return;

    	// Here's where the tip of the ship is at.
    	float sx = x + (w/2 + 2) * cos(radians(angle));
    	float sy = y - (w/2 + 2) * sin(radians(angle));
    	game.addObject(new Shot(sx, sy, dx, dy, angle));
    }

    public void drawAt(int x, int y) {
    	this.x = x;
    	this.y = y;
    	
    	this.draw();
    }
    
    final Dimension hyperspaceSafeWH = new Dimension((int)(1.5f * this.w), (int)(1.5f * this.h));
    final float hyperspaceWait = 1.0f * 1000;
    
    public void draw() {
    	if (inHyperspace != -1) {
    		// Wait before ship returns
    		if ((inHyperspace + hyperspaceWait) > millis()) {
    			return;
    		}
    		
    		// find a new point on the screen that's safe for the ship
    		Point newCenter = game.findSafeZone(hyperspaceSafeWH);
    		if (newCenter != null) {
    			println("LEAVING HYPERSPACE @ " + newCenter);
    			this.x = newCenter.x;
    			this.y = newCenter.y;
    			this.dx = this.dy = 0;
    			inHyperspace = -1;
    		}
    		else {
    			return;
    		}
    	}

        stroke(0);
        translate(x, y);
        rotate(2*PI-radians(this.angle));
        translate(-w/2, -h/2);
        line(0, 0, w, h/2);
        line(w, h/2, 0, h);
        line(w * 0.1f, h * 0.1f, w*0.1f, h - h*0.1f);
        if (showThrust) {
        	sounds.playThrust();
            showThrust = false;
            line(w * 0.1f, h * 0.1f + 2, w*0.1f - w*0.2f, (h - h*0.1f) / 2);
            line(w * 0.1f - w*0.2f, (h - h*0.1f) / 2, w*0.1f, h - h*0.1f - 2);
        }
    }
}
class Shot extends FlyingObject {
	final float speed = 10;
	final float time = 0.8f * frameRate;
    float start = frameCount;
	
	/**
	 * @param x      Shot point.
	 * @param y      Shot point
	 * @param dx     Ship trajectory.
	 * @param dx     Ship trajectory.
	 * @param angle  Ship angle in degrees.
	 */
	public Shot(float x, float y, float dx, float dy, float angle) {
		super(x, y, 1, 1, 0, 0);
		this.dx = dx + speed * cos(radians(angle));
		this.dy = dy + -speed * sin(radians(angle));
		explodes = false;
		
		sounds.fire();
	}
	
    public void update(ListIterator it) {
    	super.update(it);
    	
    	if (frameCount >= start + time)
    		remove = true;
    }

	public void draw() {
		/*
		stroke(255, 0, 0);
		fill(255, 0, 0);
		rectMode(CENTER);
		rect(x, y, 3, 3);
		*/
		stroke(0);
		point(x, y);
	}
}
class Sound {
	private AudioChannel[] channels = new AudioChannel[6];
	private final int DEFAULT_CHANNELS = 6;
		
	public Sound(String filename) {
		init(filename, DEFAULT_CHANNELS);
	}

	public Sound(String filename, int channelCount) {
		if (channelCount == -1)
			channelCount = DEFAULT_CHANNELS;

		init(filename, channelCount);
	}

	public void init(String filename, int channelCount) {
		channels = new AudioChannel[channelCount];
		
		for (int i = 0 ; i < channels.length ; i++) {
			channels[i] = new AudioChannel(filename);
			channels[i].smoothPan = true;
		}
	}
	
	public void play() {
		if (noSound) return;
		
		int which = -1;
		
		for (int i = 0; i < channels.length; i++) {
			if (channels[i].state == Ess.STOPPED) {
				which = i; // Find a free voice
			}
		}
		
		// If a voice is available and selected, play it
		if (which != -1) {
			channels[which].sampleRate(44100, false);
			channels[which].play();
		}
	}
	
	public void stop() { };
}
class SoundLoop {
	private AudioChannel channel;
	private int loops = Ess.FOREVER;
	
	public SoundLoop(String filename) {
		this.init(filename, Ess.FOREVER);
	}
	
	public SoundLoop(String filename, int loops) {
		this.init(filename, loops);
	}
	
	private void init(String filename, int loops) {
		channel = new AudioChannel(filename);
		channel.smoothPan = true;
		this.loops = loops;
	}

	public void play() {
		if (noSound) return;

		if (channel.state == Ess.PLAYING) {
			if (loops != Ess.FOREVER)
				channel.loop = channel.loop + 1;
			return;
		}
		channel.play();
		channel.loop(loops);
	}
	
	public void stop() {
		if (loops != Ess.FOREVER) return;
		channel.stop();
	}
}
class Sounds {
	public Sound[] boops = new Sound[] { new Sound ("low.wav", 1), new Sound("high.wav", 1) };
	public Sound shot = new Sound("shot.wav");
	public SoundLoop thrust = new SoundLoop("thrust.wav", 1);
	public SoundLoop smallShip = new SoundLoop("smallship.wav");
	public SoundLoop bigShip = new SoundLoop("bigship.wav");
	public Sound explodeLow = new Sound("explode_low.wav");
	public Sound explodeMedium = new Sound("explode_medium.wav");
	public Sound explodeHigh = new Sound("explode_high.wav");
	
	public void killAllSounds() {
		boops[0].stop();
		boops[1].stop();
		shot.stop();
		thrust.stop();
		smallShip.stop();
		bigShip.stop();
		explodeLow.stop();
		explodeMedium.stop();
		explodeHigh.stop();
	}
	
	public Sounds() {
		dR = (dS - dE) / N;
		println("Sounds Start Level @" + wait + " wait");
	}
	
	public void fire() { shot.play(); }
	
	public void explode(int size) {
		switch (size) {
			case EXPLODE_SMALL:
				explodeSmall();
				break;
			case EXPLODE_MEDIUM:
				explodeMedium();
				break;
			case EXPLODE_BIG:
			default:
				explodeBig();
		}
	}
	
	public void explodeSmall()  { explodeHigh.play(); }
	public void explodeMedium() { explodeMedium.play(); }
	public void explodeBig()    { explodeLow.play(); }
	
	int dS = 1000;
	int dE = 250;
	int N = 80;
	int dR, wait, start;
	int sound = 0;
	boolean inPlay = false;
	
	public void startLevel() {
		inPlay = true;
		wait = dS;
		start = millis();
		println("dS = " + dS);
		println("Sounds Start Level @" + wait + " wait, dS = " + dS);
	}

	public void playBoop() {
		if (!inPlay) return;
		
		int now = millis();
		
		//println("playBoop - interval=" + (now-start) + ", wait = " + wait);

		if (now - start > wait) {
			start = now;
			wait = max(wait - dR, dE);
			boops[sound].play();
			sound = (sound + 1) % 2;
		}
	}

	public void stopGame() {
		inPlay = false;
	}
	
	public void playThrust() { thrust.play(); }
	public void stopThrust() { thrust.stop(); }
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#DFDFDF", "asteroids" });
  }
}
